# songanalysis wrapper module
# Manuel Amador (Rudd-O) - written on 2005-11-28

from commandsplus import getstatusoutputerror
import logging

logger = logging.getLogger("songanalysis wrapper")


class NotSong(Exception): pass


def get_version():
	status,output,error = getstatusoutputerror("songanalysis -V")
	if status.command_not_found: return None
	if status.exited and status.return_value == 70: return None
	if status.exited and status.return_value == 0: return output.strip()


def get_interface():
	r = getstatusoutputerror(["songanalysis","-N"])
	if r[0].exited and r[0].return_value == 0: return r[1].strip()
	return None


def analyze_song(file):
	# may raise NotSong
		# return (tempo,freqbands,voldiff) (float,list of floats,float)
		
		logger.debug( "analyzing %s"%file)
		
		cmd = ["nice" ,"-n" ,"20" ,"songanalysis" ,file]
		status,output,error=getstatusoutputerror(cmd)
		
		if not status.exited:
			raise Exception, "songanalysis failed with status %s msg %s"%(status,error)
		if status.return_value == 70:
			raise NotSong, "%s is not a song understood by songanalysis, cannot be opened for reading or does not exist"%file

# 		self.logger.debug("analyzer spit out %s"%output)
		lines = [ l.strip() for l in output.splitlines() if l.strip() ]
		tuples = []
		for l in lines:
			key,val = l.split(":",1)
			tuples.append( (key.strip(),val.strip()) )
		
		tempo = None
		voldiff = None
		freqbands = None
		
		for t in tuples:
			key,val = t
			if key == "Volume diff": voldiff = float(val)
			if key == "Frequencies": freqbands = [ float(v) for v in val.split(" ") ]
			if key == "BPM": tempo = float(val)

		return tempo,freqbands,voldiff #if any of these is unavailable
		# we simply return None in that case
